(function ($, Drupal) {
  Drupal.behaviors.iconDialog = {
    attach: function (context, settings) {

      $(document).on('click', '#webIconModal .webicon', function (e) {
        let iconClass = $(this).data('class');
        let iconCode = $(this).data('code');
        let wrapperId = settings.webIconField.wrapperId;
        let wrapper = document.getElementById(wrapperId);
        let icon = wrapper.querySelector('.webicon-preview');
        icon.className = 'webicon-preview ' + iconClass;
        if (icon.tagName.toLowerCase() !== 'i') {
          icon.innerHTML = iconCode;
        }
        wrapper.querySelector('.icon-class').value = iconClass;
        wrapper.querySelector('.icon-code').value = iconCode;
        // Close the dialog
        $(this).closest('.ui-dialog-content').dialog('close');
      });

      $(document).on('input', '#iconFilter', function(evt) {
        let value = String(this.value);
        let filter = value.toLowerCase();
        $('.webicon').each(function() {
          let dataClass = String($(this).data('class'));
          let iconClass = dataClass.toLowerCase();
          if (iconClass.includes(filter)) {
            $(this).removeClass('webicon-hidden');
          } else {
            $(this).addClass('webicon-hidden');
          }
        });
      });

    }
  };
})(jQuery, Drupal);
