<?php

namespace Drupal\webicons\Services;

class BoxiconsIconFactory extends IconFactory {

  /**
   * {@inheritdoc}
   */
  public function getLibraryId(): string {
    return 'boxicons';
  }

  /**
   * {@inheritdoc}
   */
  public function extractFromLibrary(): array {
    $libraryInfo = $this->libraryDiscovery->getLibraryByName('webicons', $this->getLibraryId());
    $cssFile = $libraryInfo['css'][0]['data'];
    $cssContent = file_get_contents($cssFile);
    // Extract clases and codes from CSS
    preg_match_all('/\.([a-z0-9-]+):before\s*\{\s*content:\s*"\\\([a-f0-9]+)"\s*;?\s*\}/i', $cssContent, $matches);
    $icons = [];
    if (!empty($matches[1])) {
      foreach ($matches[1] as $index => $class) {
        $icons[] = [
          'class' => $class,
          'code' => $matches[2][$index],
        ];
      }
    }
    // Save icons into cache
    return $this->saveIconsIntoCache($icons);
  }

}
