<?php

namespace Drupal\webicons\Services;

class FortawesomeIconFactory extends IconFactory {

  /**
   * {@inheritdoc}
   */
  public function getLibraryId(): string {
    return 'fortawesome';
  }

  /**
   * {@inheritdoc}
   */
  public function extractFromLibrary(): array {
    $modulePath = $this->moduleHandler->getModule('webicons')->getPath();
    $iconFamilies = $modulePath . '/assets/libraries/@fortawesome/fontawesome-free/metadata/icon-families.json';
    $families = json_decode(file_get_contents($iconFamilies));
    $icons = [];
    foreach ($families as $icon => $def) {
      if (isset($def->familyStylesByLicense->free)) {
        $style = $def->familyStylesByLicense->free[0]->style;
        if (!isset($icons[$style])) {
          $icons[$style] = [];
        }
        $icons[$style][] = [
          'style' => 'fa-' . $style,
          'class' => 'fa-' . $icon,
          'code' => $def->unicode,
        ];
      }
    }
    // Save icons into cache
    return $this->saveIconsIntoCache($icons);
  }

}
