<?php

namespace Drupal\webicons\Services;

class MaterialiconsIconFactory extends IconFactory {

  /**
   * {@inheritdoc}
   */
  public function getLibraryId(): string {
    return 'materialicons';
  }

  /**
   * {@inheritdoc}
   */
  public function extractFromLibrary(): array {
    $modulePath = $this->moduleHandler->getModule('webicons')->getPath();
    $versions = $modulePath . '/assets/libraries/material-icons/_data/versions.json';
    $names = json_decode(file_get_contents($versions));
    $icons = [];
    foreach ($names as $name => $version) {
      $icons[] = [
        'class' => $name,
        'code' => '',
      ];
    }
    // Save icons into cache
    return $this->saveIconsIntoCache($icons);
  }

  /**
   * {@inheritdoc}
   */
  public function getIconRenderArray(array $keyValues, array $classes=[]): array {
    $render = parent::getIconRenderArray($keyValues, $classes);
    $render['#tag'] = 'span';
    return $render;
  }

}
